Index: Singular/LIB/hnoether.lib
===================================================================
--- Singular/LIB/hnoether.lib	(revision 54ff35fb086438cda61fdfdc9ab33efa8472e4eb)
+++ Singular/LIB/hnoether.lib	(revision 7fa60f271650fb75da945dbf4eae02cf8cc5a570)
@@ -1943,20 +1797,22 @@
 {
  //---- INPUT = poly, or HNEring --------------------
-  if (typeof(#[1])=="poly")
-  {
-    list HNEXPANSION=hnexpansion(#[1]);
-    displayMultsequence(HNEXPANSION);
-    return();
-  }
-  if (typeof(#[1])=="ring")
-  {
-    def H_N_ER_I_N_G=#[1];
-    def ret_te_ring=basering;
-    setring H_N_ER_I_N_G;
-    displayMultsequence(hne);
-    setring ret_te_ring;
-    kill H_N_ER_I_N_G;
-    return();
-  }
+ if (typeof(#[1])=="poly") {
+   list L=hnexpansion(#[1]);
+   if (typeof(L[1])=="ring") {
+     def HNring = L[1]; setring HNring;
+     displayMultsequence(hne);
+     return();
+   }
+   else {
+     displayMultsequence(L);
+     return();
+   }  
+ }
+ if (typeof(#[1])=="ring") {
+   def HNring = #[1]; setring HNring;
+   displayMultsequence(hne);
+   return();  
+ }
+
  //-- entferne ueberfluessige Daten zur Erhoehung der Rechengeschwindigkeit: --
  #=stripHNE(#);
@@ -1992,15 +1848,16 @@
    }
  }
-} // example multsequence; geht wegen echo nicht (muesste auf 3 gesetzt werden)
+} 
 example
 {
-  // ------ the example starts here -------
   "EXAMPLE:"; echo = 2;
   ring r=0,(x,y),dp;
-  //// Example 1: Input = output of develop
+  // Example 1: Input = output of develop
   displayMultsequence(develop(x3-y5));
-  //// Example 2: Input = bivariate polynomial
+
+  // Example 2: Input = bivariate polynomial
   displayMultsequence((x6-y10)*(x+y2-y3)*(x+y2+y3));
 }
+
 ///////////////////////////////////////////////////////////////////////////////
 
@@ -2556,7 +2413,7 @@
          @code{develop(f,N)}.@*
          If the matrix M of L has n columns then, compared with
-         @code{parametrisation(L)}, @code{paramametrize(extdevelop(L,N))} will increase the
+         @code{parametrization(L)}, @code{paramametrize(extdevelop(L,N))} will increase the
          exactness by at least (N-n) more significant monomials.
-SEE ALSO: develop, hnexpansion, parametrisation
+SEE ALSO: develop, hnexpansion, parametrization
 EXAMPLE: example extdevelop;  shows an example
 "
@@ -2683,30 +2540,15 @@
 example
 {
-  if (defined(HNEring))
-  {
-    def save_r_i_n_g=HNEring;
-    kill HNEring;
-  }
-  // ------ the example starts here -------
   "EXAMPLE:"; echo = 2;
   ring exring=0,(x,y),dp;
-  list hn=hnexpansion(x14-3y2x11-y3x10-y2x9+3y4x8+y5x7+3y4x6+x5*(-y6+y5)
+  list hne=hnexpansion(x14-3y2x11-y3x10-y2x9+3y4x8+y5x7+3y4x6+x5*(-y6+y5)
                       -3y6x3-y7x2+y8);
-  def HNEring=hn[1];
-  setring HNEring;  echo=0;
-  export(HNEring);  echo=2;
-  print(hne[1][1]);    // HNE of 1st branch is finite
+  displayHNE(hne);    // HNE of 1st,3rd branch is finite
   print(extdevelop(hne[1],5)[1]);
-  print(hne[2][1]);    // HNE of 2nd branch can be extended
   list ehne=extdevelop(hne[2],5);
-  print(ehne[1]);      // new HN-matrix has 5 columns
-  parametrisation(hne[2]);
-  parametrisation(ehne);
-  echo=0;
-  if (defined(save_r_i_n_g))
-  {
-    kill HNEring;
-    def HNEring=save_r_i_n_g;
-  }
+  displayHNE(ehne);
+  param(hne[2]);
+  param(ehne);
+
 }
 ///////////////////////////////////////////////////////////////////////////////
@@ -2786,6 +2628,6 @@
 proc factorfirst(poly f, int M, int N)
 "USAGE : factorfirst(f,M,N); f poly, M,N int
-RETURN: number d: f=c*(y^(N/e) - d*x^(M/e))^e with e=gcd(M,N), number c fitting
-        0 if d does not exist
+RETURN: number d such that f=const*(y^(N/e) - d*x^(M/e))^e, where e=gcd(M,N), 
+        0 if such a d does not exist
 EXAMPLE: example factorfirst;  shows an example
 "
@@ -2832,59 +2674,68 @@
 }
 
-///////////////////////////////////////////////////////////////////////////////
-//         
-//  the command HNdevelop is obsolete  --> here is the former help string:
-//
-///////////////////////////////////////////////////////////////////////////////
-//
-//ASSUME:  f is a bivariate polynomial (in the first 2 ring variables)
-//CREATE:  ring with name @code{HNEring}, variables @code{x,y} and ordering
-//         @code{ls} over a field extension of the current basering's ground
-//         field. @*
-//         Since the Hamburger-Noether development usually does not exist
-//         in the originally given basering, @code{HNdevelop} always defines
-//         @code{HNEring} and CHANGES to it. The field extension is chosen
-//         minimally.
-//RETURN:  list @code{L} of lists @code{L[i]} (corresponding to the output of
-//         @code{develop(f[i])}, f[i] a branch of f, but the last entry being
-//         omitted).
-//@texinfo
-//@table @asis
-//@item @code{L[i][1]}; matrix:
-//         Each row contains the coefficients of the corresponding line of the
-//         Hamburger-Noether expansion (HNE) for f[i]. The end of the line is
-//         marked in the matrix by the first ring variable (usually x).
-//@item @code{L[i][2]}; intvec:
-//         indicating the length of lines of the HNE
-//@item @code{L[i][3]}; int:
-//         0  if the 1st ring variable was transversal (with respect to f[i]), @*
-//         1  if the variables were changed at the beginning of the
-//            computation, @*
-//        -1  if an error has occurred.
-//@item @code{L[i][4]}; poly:
-//         the transformed polynomial of f[i] to make it possible to extend the
-//         Hamburger-Noether development a posteriori without having to do
-//         all the previous calculation once again (0 if not needed)
-//@end table
-//@end texinfo
-//NOTE:    @code{HNdevelop} decides which procedure (@code{develop} or
-//         @code{reddevelop}) applies best to the given problem and calls it. @*
-//         If f is known to be irreducible as a power series, @code{develop(f)}
-//         should be chosen instead to avoid the change of basering. @*
-//         If @code{printlevel>=2} comments are displayed (default is
-//         @code{printlevel=0}).
-//
-//EXAMPLE: example HNdevelop;  shows an example
-//
-proc HNdevelop (poly f)
-"USAGE:   HNdevelop(f); f poly
-NOTE:     command is obsolete, use hnexpansion(f) instead.
-SEE ALSO: hnexpansion, develop, extdevelop, param, displayHNE
+///////////////////////////////////////////////////////////////////////////
+
+proc hnexpansion(poly f,list #)
+"USAGE:   hnexpansion(f[,\"ess\"]);   f poly
+ASSUME:  f is a bivariate polynomial (in the first 2 ring variables)
+RETURN:  list @code{L}, containing Hamburger-Noether data of @code{f}:
+         If the computation of the HNE required no field extension, @code{L} 
+         is a list of lists @code{L[i]} (corresponding to the output of 
+         @code{develop}, applied to a branch of @code{f}, but the last entry
+         being omitted):
+@texinfo
+@table @asis
+@item @code{L[i][1]}; matrix:
+         Each row contains the coefficients of the corresponding line of the
+         Hamburger-Noether expansion (HNE) for the i-th branch. The end of 
+         the line is marked in the matrix by the first ring variable 
+         (usually x).
+@item @code{L[i][2]}; intvec:
+         indicating the length of lines of the HNE
+@item @code{L[i][3]}; int:
+         0  if the 1st ring variable was transversal (with respect to the 
+            i-th branch), @*
+         1  if the variables were changed at the beginning of the
+            computation, @*
+        -1  if an error has occurred.
+@item @code{L[i][4]}; poly:
+         the transformed equation of the i-th branch to make it possible 
+         to extend the Hamburger-Noether data a posteriori without having 
+         to do all the previous calculation once again (0 if not needed).
+@end table
+@end texinfo
+         If the computation of the HNE required a field extension, the first
+         entry @code{L[1]} of the list is a ring, in which a list @code{hne}
+         of lists (the HN data, as above) and a poly @code{f} (image of 
+         @code{f} over the new field) are stored. 
+         @*
+         If called with an additional input parameter, @code{hnexpansion} 
+         computes only one representative for each class of conjugate 
+         branches (over the ground field active when calling the procedure). 
+         In this case, the returned list @code{L} always has only two 
+         entries: @code{L[1]} is either a list of lists (the HN data) or a 
+         ring (as above), and @code{L[2]} is an integer vector (the number
+         of branches in the respective conjugacy classes).
+
+NOTE:    If f is known to be irreducible as a power series, @code{develop(f)}
+         could be chosen instead to avoid a change of basering during the 
+         computations. @*
+         Increasing  @code{printlevel} leads to more and more comments. @*
+         Having defined a variable @code{HNDebugOn} leads to a maximum
+         number of comments.
+
+SEE ALSO: develop, extdevelop, parametrization, displayHNE
+EXAMPLE: example hnexpansion;  shows an example
 "
 {
- int irred=0;
+ int essential; 
+ if (size(#)==1) { essential=1; }
+ int field_ext;
+ def altring=basering;
+
  //--------- Falls Ring (p^k,a),...: Wechsel in (p,a),... + minpoly -----------
- if ((find(charstr(basering),string(char(basering)))!=1) &&
-     (charstr(basering)<>"real")) {
+ if ( (find(charstr(basering),string(char(basering)))!=1) &&
+      (charstr(basering)<>"real")&&
+      (charstr(basering)<>"complex") ) {
    string strmip=string(minpoly);
    string strf=string(f);
@@ -2893,206 +2744,113 @@
    execute("minpoly="+strmip+";");
    execute("poly f="+strf+";");
-   list hne=reddevelop(f);
+   field_ext=1;
+   def L=pre_HN(f,essential);
+   if (size(L)==0) { return(list()); }
+   def HNEring=L[1];
+   setring HNEring;
+   if ((typeof(hne[1])=="ideal")) { return(list()); }
    if ((voice==2) && (printlevel > -1)) {
-     "// Attention: The parameter",par(1),"has changed its meaning!";
-     "// It need no longer be a generator of the cyclic group of unities!";
-   }
+     "// Attention: The parameter",par(1),"may have changed its meaning!";
+     "// It needs no longer be a generator of the cyclic group of unities!";
+   }
+   dbprint(printlevel-voice+2,
+     "// result: "+string(size(hne))+" branch(es) successfully computed.");
  }
  else {
- //--- Falls Ring (0,a),... + minpoly : solange factorize nicht in Singular ---
- //------- implementiert ist, develop aufrufen (kann spaeter entfallen) -------
- //
- // **** lossen: gestrichen 08/05  ****
- //   if ((char(basering)==0) && (npars(basering)==1)) {
- //     if (string(minpoly)<>"0") { irred=1; }
- //   }
- //
- //------------------ Aufruf der geeigneten Prozedur --------------------------
-   if (irred==0) {
-     list hne=pre_HN(f,0);       // = reddevelop(f);
-     dbprint(printlevel-voice+2,
-        "// result: "+string(size(hne))+" branch(es) successfully computed,",
-        "//         basering has changed to HNEring");
+   def L=pre_HN(f,essential);
+   if (size(L)==0) { return(list()); }
+   if (L[2]==1) { field_ext=1; }
+   intvec hne_conj=L[3];
+   def HNEring=L[1];
+   setring HNEring;
+   if ((typeof(hne[1])=="ideal")) { return(list()); }
+   dbprint(printlevel-voice+2,
+      "// result: "+string(size(hne))+" branch(es) successfully computed.");
+ }
+ if (field_ext==1) {
+   dbprint(printlevel-voice+3,"
+// 'hnexpansion' created a list of one ring.
+// To see the ring and the data stored in the ring, type (if you assigned 
+// the name L to the list): 
+     show(L);
+// To display the computed HN expansion, type 
+     def HNring = L[1]; setring HNring;  displayHNE(hne); ");
+   if (essential==1) {
+     dbprint(printlevel-voice+3,""+
+"// As second entry of the returned list L, you obtain an integer vector, 
+// indicating the number of conjugates for each of the computed branches.");
+     return(list(HNEring,hne_conj));
+   }   
+   return(list(HNEring));
+ }
+ else { // no change of basering necessary --> map data to original ring
+   setring altring;
+   if ((npars(altring)==1) and (minpoly!=0)) {
+     ring HNhelpring=char(altring),(a,x,y),ls;
+     list hne=imap(HNEring,hne);
+     setring altring;
+     map m=HNhelpring,par(1),var(1),var(2);
+     list hne=m(hne);
+     kill m,HNhelpring;
+   }
+   else {   
+     list hne=fetch(HNEring,hne);
+   }
+   kill HNEring;
+   if (essential==1) {
+     dbprint(printlevel-voice+3,"
+// No change of ring necessary, return value is a list:
+//   first entry  =  list :  HN expansion of essential branches.
+//   second entry =  intvec: numbers of conjugated branches 
+     ");
+     return(list(hne,hne_conj));
    }
    else {
-     def altring=basering;
-     string strmip=string(minpoly);
-     ring HNEring=(char(altring),`parstr(altring)`),(x,y),ls;
-     execute("minpoly="+strmip+";");
-     export HNEring;
-     poly f=fetch(altring,f);
-     list hn=develop(f,-1);
-     list hne;
-     if (hn[3] <> -1) {
-       hne[1]=list(hn[1],hn[2],hn[3],hn[4]);
-       if (hn[5] <> 1) {
-   " ** WARNING : The curve is reducible, but only one branch could be found!";
-       }
-     }
-     else { " ** Sorry -- could not find a HNE."; }
-     dbprint(printlevel-voice+2,"// note: basering has changed to HNEring");
-   }
- }
- export hne;
- keepring basering;
- return(hne);
+     dbprint(printlevel-voice+3,"
+// No change of ring necessary, return value is HN expansion.
+     ");
+     return(hne);
+   }
+ }
 }
 example
 {
-  // -------- prepare for example ---------
-  if (nameof(basering)=="HNEring") {
-   def rettering=HNEring;
-   kill HNEring;
-  }
-  // ------ the example starts here -------
   "EXAMPLE:"; echo = 2;
   ring r=0,(x,y),dp;
-  list hne=HNdevelop(x4-y6);
-  nameof(basering);
+  // First, an example which requires no field extension:
+  list hne=hnexpansion(x4-y6);
   size(hne);           // number of branches
-  print(hne[1][1]);    // HN-matrix of 1st branch
+  displayHNE(hne);     // HN expansion of branches
   param(hne[1]);       // parametrization of 1st branch
   param(hne[2]);       // parametrization of 2nd branch
-  kill HNEring,r;
-  echo = 0;
-  // --- restore HNEring if previously defined ---
-  if (defined(rettering)) {
-   setring rettering;
-   def HNEring=rettering;
-   export HNEring;
-  }
-}
-
-///////////////////////////////////////////////////////////////////////////////
-//         
-//  the command reddevelop is obsolete  --> here is the former help string:
-//
-///////////////////////////////////////////////////////////////////////////////
-//ASSUME:  f is a bivariate polynomial (in the first 2 ring variables)
-//CREATE:  ring with name @code{HNEring}, variables @code{x,y} and ordering
-//         @code{ls} over a field extension of the current basering's ground
-//         field. @*
-//         Since the Hamburger-Noether development of a reducible curve
-//         singularity usually does not exist in the originally given basering,
-//         @code{reddevelop} always defines @code{HNEring} and CHANGES to it.
-//         The field extension is chosen minimally.
-//RETURN:  list @code{L} of lists @code{L[i]} (corresponding to the output of
-//         @code{develop(f[i])}, f[i] a branch of f, but the last entry being
-//         omitted).
-//@texinfo
-//@table @asis
-//@item @code{L[i][1]}; matrix:
-//         Each row contains the coefficients of the corresponding line of the
-//         Hamburger-Noether expansion (HNE) for f[i]. The end of the line is
-//         marked in the matrix by the first ring variable (usually x).
-//@item @code{L[i][2]}; intvec:
-//         indicating the length of lines of the HNE
-//@item @code{L[i][3]}; int:
-//         0  if the 1st ring variable was transversal (with respect to f[i]), @*
-//         1  if the variables were changed at the beginning of the
-//            computation, @*
-//        -1  if an error has occurred.
-//@item @code{L[i][4]}; poly:
-//         the transformed polynomial of f[i] to make it possible to extend the
-//         Hamburger-Noether development a posteriori without having to do
-//         all the previous calculation once again (0 if not needed)
-//@end table
-//@end texinfo
-//NOTE:    If @code{printlevel>=0} comments are displayed (default is
-//         @code{printlevel=0}).
-//
-//EXAMPLE: example reddevelop;  shows an example
-//
-proc reddevelop (poly f)
-"USAGE:   reddevelop(f); f poly
-NOTE:     command is obsolete, use hnexpansion(f) instead.   
-SEE ALSO: hnexpansion, develop, extdevelop, param, displayHNE
-"
-{
- list Ergebnis=pre_HN(f,0);
- if (size(Ergebnis)>0) {     // otherwise an error may have occurred
-  dbprint(printlevel-voice+2,
-   "// result: "+string(size(Ergebnis))+" branch(es) successfully computed,",
-   "//         basering has changed to HNEring");
- }
-
- // ----- Lossen 10/02 : the branches have to be resorted to be able to
- // -----                display the multsequence in a nice way
- if (size(Ergebnis)>2)
- {  
-   int i,j,k,m;
-   list dummy;
-   int nbsave;
-   int no_br = size(Ergebnis);
-   intmat nbhd[no_br][no_br];
-   for (i=1;i<no_br;i++)
-   {
-     for (j=i+1;j<=no_br;j++)  
-     { 
-       nbhd[i,j]=separateHNE(Ergebnis[i],Ergebnis[j]);
-       k=i+1;
-       while ( (nbhd[i,k] >= nbhd[i,j]) and (k<j) )
-       {
-         k++;
-       }
-       if (k<j)  // branches have to be resorted 
-       {
-         dummy=Ergebnis[j];
-         nbsave=nbhd[i,j];
-         for (m=k; m<j; m++)
-         {
-           Ergebnis[m+1]=Ergebnis[m];
-           nbhd[i,m+1]=nbhd[i,m];
-         }
-         Ergebnis[k]=dummy;
-         nbhd[i,k]=nbsave;
-       }
-     }
-   }
- }
- // -----
- 
- export Ergebnis;
- keepring basering;
- return(Ergebnis);
-}
-example
-{
-  // -------- prepare for example ---------
-  if (nameof(basering)=="HNEring")
-  {
-   def rettering=HNEring;
-   kill HNEring;
-  }
-  // ------ the example starts here -------
-  "EXAMPLE:"; echo = 2;
-  ring r = 32003,(x,y),dp;
-  poly f = x25+x24-4x23-1x22y+4x22+8x21y-2x21-12x20y-4x19y2+4x20+10x19y
-          +12x18y2-24x18y-20x17y2-4x16y3+x18+60x16y2+20x15y3-9x16y
-          -80x14y3-10x13y4+36x14y2+60x12y4+2x11y5-84x12y3-24x10y5
-          +126x10y4+4x8y6-126x8y5+84x6y6-36x4y7+9x2y8-1y9;
-  list hne=reddevelop(f);
-  size(hne);            // number of branches
-  print(hne[1][1]);     // HN-matrix of 1st branch
-  print(hne[4][1]);     // HN-matrix of 4th branch
-  // a ring change was necessary, a is a parameter
-  HNEring;
-  kill HNEring,r;
-  echo = 0;
-  // --- restore HNEring if previously defined ---
-  if (defined(rettering)) {
-   setring rettering;
-   def HNEring=rettering;
-   export HNEring;
-  }
-}
+
+  // An example which requires a field extension:
+  list L=hnexpansion((x4-y6)*(y2+x4));
+  def R=L[1]; setring R; displayHNE(hne);
+  basering;
+  setring r; kill R;
+  
+  // Computing only one representative per conjugacy class:
+  L=hnexpansion((x4-y6)*(y2+x4),"ess");
+  def R=L[1]; setring R; displayHNE(hne);
+  L[2];     // number of branches in respective conjugacy classes
+}
+
 ///////////////////////////////////////////////////////////////////////////////
 
 static proc pre_HN (poly f, int essential)
 "NOTE: This procedure is only for internal use, it is called via
-      reddevelop or essdevelop"
+       hnexpansion
+RETURN: list:  first entry = HNEring  (containing list hne, poly f)
+               second entry = 0  if no change of base ring necessary
+                              1  if change of base ring necessary
+               third entry = numbers of conjugates ( if essential = 1 ) 
+        if some error has occured, the empty list is returned
+" 
 {
  def altring = basering;
- int p = char(basering);                 // Ringcharakteristik
+ int p = char(basering);
+ int field_ext;
+ intvec hne_conj;
 
  //-------------------- Tests auf Zulaessigkeit von basering ------------------
@@ -3119,8 +2877,9 @@
  //----------------- Definition eines neuen Ringes: HNEring -------------------
  string namex=varstr(1); string namey=varstr(2);
- if (string(char(altring))==charstr(altring)) {       // kein Parameter
+ if (string(char(altring))==charstr(altring)) { // kein Parameter, nicht 'real'
    ring HNEring = char(altring),(x,y),ls;
    map m=altring,x,y;
    poly f=m(f);
+   export f;
    kill m;
  }
@@ -3128,10 +2887,9 @@
    string mipl=string(minpoly);
    if (mipl=="0") {
-     " ** WARNING: No algebraic extension of this ground field is possible!";
-     " ** We try to develop this polynomial, but if the need for an extension";
-     " ** occurs during the calculation, we cannot proceed with the";
-     " ** corresponding branches ...";
+     "// ** WARNING: Algebraic extension of given ground field not possible!";
+     "// ** We try to develop this polynomial, but if the need for a field";
+     "// ** extension occurs during the calculation, we cannot proceed with"; 
+     "// ** the corresponding branches.";
      execute("ring HNEring=("+charstr(basering)+"),(x,y),ls;");
- //--- ring ...=(char(.),`parstr()`),... geht nicht, wenn mehr als 1 Param. ---
    }
    else {
@@ -3142,16 +2900,29 @@
     map getminpol=HNhelpring,a;
     mipl=string(getminpol(mipo));    // String umgewandelt mit 'a' als Param.
-    execute("minpoly="+mipl+";");     // "minpoly=poly is not supported"
+    execute("minpoly="+mipl+";");    // "minpoly=poly is not supported"
     kill HNhelpring, getminpol;
    }
-   if (nvars(altring)==2) { poly f=fetch(altring,f); }
+   if (nvars(altring)==2) {
+     poly f=fetch(altring,f);
+     export f;
+   }
    else {
-     map m=altring,x,y;
-     poly f=m(f);
+     if (defined(pa)) { // Parameter hatte vorher anderen Namen als 'a'
+       ring HNhelpring=p,(`pa`,x,y),ls;
+       poly f=imap(altring,f);
+       setring HNEring;
+       map m=HNhelpring,a,x,y;
+       poly f=m(f);
+       kill HNhelpring;
+     }
+     else {
+       map m=altring,x,y;
+       poly f=m(f);
+     }
+     export f;
      kill m;
    }
  }
- export HNEring;
-
+ 
  if (defined(HNDebugOn))
  {"received polynomial: ",f,", with x =",namex,", y =",namey;}
@@ -3160,5 +2931,9 @@
  int Abbruch,i,NullHNEx,NullHNEy;
  string str;
- list Newton,Ergebnis,hilflist;
+ list Newton,hne; 
+
+ // --- changed for SINGULAR 3: ---
+ hne=ideal(0);
+ export hne;
 
  //====================== Tests auf Zulaessigkeit des Polynoms ================
@@ -3168,10 +2943,10 @@
    dbprint(printlevel+1,
            "The given polynomial is a unit in the power series ring!");
-   keepring HNEring;
+   setring altring; kill HNEring;
    return(list());                   // there are no HNEs
  }
  if (f==0) {
    dbprint(printlevel+1,"The given polynomial is zero!");
-   keepring HNEring;
+   setring altring; kill HNEring;
    return(list());                   // there are no HNEs
  }
@@ -3228,5 +3003,4 @@
        if (str<>"c") {
          setring altring;
-         if(system("with","Namespaces")) { kill Top::HNEring; }
          kill HNEring;kill zweitring;
          return(list());}
@@ -3263,7 +3037,7 @@
        " (c) continue with a squarefree divisor (but factors of the form g^"
        +string(p);
-       "     are lost; this is recommended, takes no more time)";
+       "     are lost; this is recommended, takes no extra time)";
        " (f) continue with the full radical (using a factorization of the";
-       "     pure power part; this could take much time)";
+       "     pure power part; this could take some time)";
        " (q) quit the algorithm";
        "";"Please enter the letter of your choice:";
@@ -3281,10 +3055,8 @@
      "            printlevel=1;";
      "//   before calling me with a non-squarefree f.";
-     "//   If printlevel > 0, I will present to you some possibilities how to",
-       "proceed.";
+     "//   If printlevel > 0, I present some possibilities how to proceed.";
      str="q";
    }
    if (str=="q") {
-    if(system("with","Namespaces")) { kill Top::HNEring; }
     setring altring;kill HNEring;
     return(list());
@@ -3298,6 +3070,6 @@
  //====================== Ende Test auf Quadratfreiheit =======================
  if (subst(subst(f,x,0),y,0)!=0) {
-   "Sorry. The remaining polynomial is a unit in the power series ring...";
-   keepring HNEring;
+   "The polynomial is a unit in the power series ring. No HNE computed.";
+   setring altring;kill HNEring;
    return(list());
  }
@@ -3327,8 +3099,6 @@
  // Binde die Listen (azeilen,...) an den Ring (um sie nicht zu ueberschreiben
  // bei Def. in einem anderen Ring).
- // Exportiere Objekte, damit sie auch in der proc HN noch da sind
  //----------------------------------------------------------------------------
  ring HNE_noparam = char(altring),(a,x,y),ls;
- export HNE_noparam;
  poly f;
  list azeilen=ideal(0);
@@ -3336,10 +3106,16 @@
  list aneu=ideal(0);
  list faktoren=ideal(0);
+
  ideal deltais;
- poly delt;                   // nicht number, weil delta von a abhaengen kann
- export f,azeilen,HNEs,aneu,faktoren,deltais,delt;
+ poly delt;
+
  //----- hier steht die Anzahl bisher benoetigter Ringerweiterungen drin: -----
- int EXTHNEnumber=0; export EXTHNEnumber;
+ int EXTHNEnumber=0; 
+
+ list EXTHNEring;
+ list HNE_RingDATA;
+ int number_of_letztring;
  setring HNEring;
+ number_of_letztring=0;
 
  // ================= Die eigentliche Berechnung der HNE: =====================
@@ -3349,20 +3125,39 @@
    {"1st step: Treat Newton polygon until height",grenze1;}
  if (grenze1>0) {
-  hilflist=HN(f,grenze1,1,essential);
-  if (typeof(hilflist[1][1])=="ideal") { hilflist[1]=list(); }
- //- fuer den Fall, dass keine Zweige in transz. Erw. berechnet werden konnten-
-  Ergebnis=extractHNEs(hilflist[1],0);
-  if (hilflist[2]!=-1) {
-    if (defined(HNDebugOn)) {" ring change in HN(",1,") detected";}
-    poly transfproc=hilflist[2];
-    map hole=HNE_noparam,transfproc,x,y;
-    setring HNE_noparam;
-    f=imap(HNEring,f);
-    setring EXTHNEring(EXTHNEnumber);
-    poly f=hole(f);
-  }
- }
+  if (EXTHNEnumber>0){ EXTHNEring = EXTHNEring(1..EXTHNEnumber); }
+  HNE_RingDATA = list(HNEring, HNE_noparam, EXTHNEnumber, EXTHNEring, 
+                      number_of_letztring); 
+
+  list hilflist=HN(HNE_RingDATA,f,grenze1,1,essential,0,hne_conj,1);
+  kill HNEring, HNE_noparam;
+  if (EXTHNEnumber>0) { kill EXTHNEring(1..EXTHNEnumber);}
+  def HNEring = hilflist[1][1];
+  def HNE_noparam = hilflist[1][2];
+  EXTHNEnumber = hilflist[1][3];
+  for (i=1; i<=EXTHNEnumber; i++) { def EXTHNEring(i)=hilflist[1][4][i]; }
+  if (hilflist[2]==0) { setring HNEring; number_of_letztring=0; }
+  else                { setring EXTHNEring(hilflist[2]);}
+  if (hilflist[3]==1){field_ext=1;}
+  hne_conj=hilflist[5];
+
+  if (number_of_letztring != hilflist[2])
+  {  // Ringwechsel in Prozedur HN
+     map hole=HNE_noparam,transfproc,x,y;
+     setring HNE_noparam;
+     if (not(defined(f))) {poly f;}
+     f=imap(HNEring,f);
+     setring EXTHNEring(EXTHNEnumber);
+     if (not(defined(f))) {poly f; f=hole(f); export f;}
+     else                 {f=hole(f);}
+  } 
+  number_of_letztring = hilflist[2];
+  kill hilflist; 
+ }
+
  if (NullHNEy==1) {
-  Ergebnis=Ergebnis+list(list(matrix(ideal(0,x)),intvec(1),int(0),poly(0)));
+  if ((typeof(hne[1])=="ideal")) { hne=list(); }
+  hne=hne+list(list(matrix(ideal(0,x)),intvec(1),int(0),poly(0)));
+  if (hne_conj==0) { hne_conj=1; }
+  else { hne_conj = hne_conj, 1; }
  }
  // --------------- Berechne HNE von allen verbliebenen Zweigen: --------------
